local L = LibStub("AceLocale-3.0"):GetLocale("Chinon")


local function CreerOptionSkin(option)
	local l =
	{
		color = 
		{
			order = 1,
			type = "color",
			hasAlpha = true,
			name = L["Couleur de fond"],
			get = function (info)
				return Chinon.apparence[option].color.r,
					Chinon.apparence[option].color.g,
					Chinon.apparence[option].color.b,
					Chinon.apparence[option].color.a
			end,
			set = function(info,r,g,b,a)
				Chinon.apparence[option].color.r = r
				Chinon.apparence[option].color.g = g
				Chinon.apparence[option].color.b = b
				Chinon.apparence[option].color.a = a
				Chinon_Frame:Update()
			end
		},
		skinBackground =
		{
			order = 2,
			type = "select",
			dialogControl = 'LSM30_Background',
			name = L["Image de fond"],
			values = AceGUIWidgetLSMlists.background,
			get = function(info) return Chinon.apparence[option].background; end,
			set = function(info,value) Chinon.apparence[option].background = value; Chinon_Frame:Update() end
		},
		skinBorder =
		{
			order = 3, 
			type = "select",
			dialogControl = 'LSM30_Border',
			name = L["Image de bordure"],
			values = AceGUIWidgetLSMlists.border,
			get = function(info) return Chinon.apparence[option].border; end,
			set = function(info,value) Chinon.apparence[option].border = value; Chinon_Frame:Update() end
		},
		tile = 
		{
			order = 4,
			type = "toggle",
			order = 5,
			name = L["Répéter fond"],
			desc = L["L'image de fond doit être répétée"],
			get = function(info) return Chinon.apparence[option].tile; end,
			set = function(info,value) Chinon.apparence[option].tile = value; Chinon_Frame:Update() end
		},
		tileSize = 
		{
			order = 5,
			type = "range",
			name = L["Taille du fond"],
			desc = L["La taille utilisée pour répéter l'image de fond"],
			min = 16, max = 256, step = 1,
			disabled = function() return not Chinon.apparence[option].tile end,
			get = function(info) return Chinon.apparence[option].tileSize; end,
			set = function(info,value) Chinon.apparence[option].tileSize = value; Chinon_Frame:Update() end
		},
		edgeSize = 
		{
			type = "range",
			order = 7,
			name = L["Épaisseur de la bordure"],
			min = 1, max = 16, step = 1,
			get = function(info) return Chinon.apparence[option].edgeSize; end,
			set = function(info, value) Chinon.apparence[option].edgeSize = value; Chinon_Frame:Update() end
		}									
	}
	return l
end

chinonOptionsInterface = 
{ 
    type='group',
    args = 
    {
		apparence =
		{
			type='group',
			name=L['Apparence'],
			args=
			{
				largeurBouton = 
				{
					order= 0,
					type = 'range',
					name = L["Largeur boutons"],
					desc = L["Change la largeur des boutons."],
					get = function(info) return Chinon.apparence.largeurBouton end,
					set = function(info,v) Chinon.apparence.largeurBouton = v; Chinon_Frame:Update() end,
					min = 16,
					max = 128,
					step = 1
				},
				hauteurBouton =
				{
					order = 1,
					type = 'range',
					name = L["Hauteur boutons"],
					desc = L["Change la hauteur des boutons."],
					get = function(info) return Chinon.apparence.hauteurBouton end,
					set = function(info,v) Chinon.apparence.hauteurBouton = v; Chinon_Frame:Update() end,
					min = 16,
					max = 128,
					step = 1
				},
				largeurBoutonCD = 
				{
					order = 2,
					type = 'range',
					name = L["Largeur boutons haut"],
					desc = L["Change la largeur des boutons."],
					get = function(info) return Chinon.apparence.largeurBoutonCD end,
					set = function(info,v) Chinon.apparence.largeurBoutonCD = v; Chinon_Frame:Update() end,
					min = 16,
					max = 64,
					step = 1
				},
				hauteurBoutonCD =
				{
					order= 3,
					type = 'range',
					name = L["Hauteur boutons haut"],
					desc = L["Change la hauteur des boutons."],
					get = function(info) return Chinon.apparence.hauteurBoutonCD end,
					set = function(info,v) Chinon.apparence.hauteurBoutonCD = v; Chinon_Frame:Update() end,
					min = 16,
					max = 64,
					step = 1
				},
				classerParGroupe =
				{
					order = 4,
					type = 'toggle',
					name = L["Classer par groupe"],
					desc = L["En affichage de raid, classer les joueurs par groupe"],
					get = function(info) return Chinon.apparence.classerParGroupe end,
					set = function(info,v) Chinon.apparence.classerParGroupe=v;Chinon_Frame:Update() end
				},
				showGroupeSeulement =
				{
					order = 5,
					type = "toggle",
					name = L["Montrer en groupe seulement"],
					desc = L["Quand vous n'êtes pas groupé, la fenêtre est cachée"],
					get = function(info) return Chinon.apparence.showGroupeSeulement end,
					set = function(info,v) Chinon.apparence.showGroupeSeulement=v;Chinon_Frame:Update() end
				},
				hideLigneCible = 
				{
					order = 6,
					type = "toggle",
					name = L["Cacher la première ligne"],
					desc = L["Cacher la ligne qui contient le joueur, sa cible, la cible de la cible et le focus"],
					get = function(info) return Chinon.apparence.hideLigneCible end,
					set = function(info,v) Chinon.apparence.hideLigneCible=v;Chinon_Frame:Update() end
				},
				frame =
				{
					order = 7,
					type = "group",
					name = L["Apparence de la fenêtre"],
					args = CreerOptionSkin("frameSkin")
				},
				button =
				{
					order = 8,
					type = "group",
					name = L["Apparence des boutons"],
					args = CreerOptionSkin("buttonSkin")
				},
				lock =
				{
					order = 9,
					type = "toggle",
					name = L["Verrouiller la position de la fenêtre"],
					get = function(info) return Chinon.apparence.lockFrame end,
					set = function(info,v) Chinon.apparence.lockFrame=v;end
				}
			}
		},
		boutons =
		{
			type='group',
			name=L['Boutons'],
		},
		cd =
		{
			type='group',
			name=L['Temps de recharge']
		},
		sb =
		{
			type="group",
			name=L["Mes améliorations"]
		},
		warning =
		{
			type="group",
			name=L["Affaiblissements graves"]
		},
		add =
		{
			type="execute",
			order = -3,
			name=L["Ajouter la cible"],
			func = function()
				Chinon:AddCustomTarget("")
			end,
			guiHidden = true			
		},
		addpet=
		{
			type="execute",
			order = -4,
			name=L["Ajouter le familier de la cible"],
			func = function()
				Chinon:AddCustomTarget("pet")
			end,
			guiHidden = true
		},
		remove =
		{
			type="execute",
			order = -4,
			name=L["Enlever la cible"],
			func = function()
				Chinon:RemoveCustomTarget("")
			end,
			guiHidden = true
		},
		removepet =
		{
			type="execute",
			order = -4,
			name=L["Enlever le familier de la cible"],
			func = function()
				Chinon:RemoveCustomTarget("pet")
			end,
			guiHidden = true
		}
	}
};

chinonDefautArgsWarning=
{
	nom =
	{
		order = 0,
		type = "input",
		name = L["Sort"],
		desc = L["Le numéro ou le nom du sort"],
		validate = function(info, test) 
			return (string.match(test,"%d+") and Chinon:GetSpellInfoOrNil(test)~=nil)
				or Ovale:GetSpellIdByName(test)~=nil
		end,
		get = function(info) return Chinon.sortNouveauWarning end,
		set = function(info, v) 
			if (string.match(v, "%d")) then
				Chinon.sortNouveauWarning = v 
			else
				Chinon.sortNouveauWarning = Chinon:GetSpellInfoOrNil(v)
			end
		end
	},
	ajouter =
	{
		order = 1,
		type = "execute",
		name = L["Ajouter"],
		func = function(input)
			if (Chinon.sortNouveauWarning and not chinonOptionsInterface.args.warning.args[Chinon.sortNouveauCD]) then
				Chinon.warningSpell[Chinon.sortNouveauWarning] = true
				Chinon:UpdateListeWarning();
				Chinon:AjouterBoutonWarning(Chinon.sortNouveauWarning)
			end
		end
	}
}

chinonDefautArgsCD=
{
	nom =
	{
		order = 0,
		type = "select",
		name = L["Sort"],
		values = Chinon.sorts,
		get = function(info) return Chinon:GetSpellInfoOrNil(Chinon.sortNouveauCD) end,
		set = function(info, v) Chinon.sortNouveauCD = Chinon:GetSpellIdByName(v) end
	},
	ajouter =
	{
		order = 1,
		type = "execute",
		name = L["Ajouter"],
		func = function(input)
			if (Chinon.sortNouveauCD and not chinonOptionsInterface.args.cd.args[Chinon.sortNouveauCD]) then
				Chinon.cfgBoutonsCD[#Chinon.cfgBoutonsCD+1] = Chinon.sortNouveauCD
				Chinon:AjouterBoutonCD(Chinon.sortNouveauCD)
				Chinon_Frame:Update()
			end
		end
	}
}

chinonDefautArgsSB=
{
	nom =
	{
		order = 0,
		type = "input",
		name = L["Sort"],
		desc = L["Le numéro du sort d'amélioration lancé sur vous"],
		validate = function(info, test) 
			return (string.match(test,"%d+") and Chinon:GetSpellInfoOrNil(test)~=nil)
				or Ovale:GetSpellIdByName(test)~=nil
		end,
		get = function(info) return Chinon.sortNouveauSB end,
		set = function(info, v) 
			if (string.match(v, "%d")) then
				Chinon.sortNouveauSB = v 
			else
				Chinon.sortNouveauSB = Chinon:GetSpellInfoOrNil(v)
			end
		end
	},
	ajouter =
	{
		order = 1,
		type = "execute",
		name = L["Ajouter"],
		func = function(input)
			if (Chinon.sortNouveauSB and not chinonOptionsInterface.args.sb.args[Chinon.sortNouveauSB]) then
				Chinon.cfgBoutonsSB[#Chinon.cfgBoutonsSB+1] = Chinon.sortNouveauSB
				Chinon:AjouterBoutonSB(Chinon.sortNouveauSB)
				Chinon_Frame:Update()
			end
		end
	}
}

chinonDefautArgsBouton=
{
	nom =
	{
		order=  0,
		type = "input",
		name = L["Nom du bouton"],
		get = function(info) return Chinon.apparence.nomNouveauBouton end,
		set = function(info, v) Chinon.apparence.nomNouveauBouton = v end
	},
	ajouter =
	{
		order = 1,
		type = "execute",
		name = L["Ajouter"],
		func = function(input)
			if (Chinon.apparence.nomNouveauBouton and not chinonOptionsInterface.args.boutons.args[Chinon.apparence.nomNouveauBouton]) then
				local nouveauBouton = { nom = Chinon.apparence.nomNouveauBouton, arene=true, groupe=true, raid=true }
				Chinon.cfgBoutons[#Chinon.cfgBoutons+1] = nouveauBouton
				Chinon:AjouterOptionsBouton(nouveauBouton)
				Chinon_Frame:Update()
			end
		end
	}
}
